//AddGuides.js
//An InDesign CS JavaScript
//
//This script draws guides around the selected object or objects.
//Choose Visible Bounds to consider the stroke weight of the paths when placing the guides, 
//or choose Geometric Bounds to ignore the stroke weight when placing the guides
//Choose Each Item to position the guides around individual items in the selection, 
//or Entire Selection to position the guides around the selection as a whole.
//
//For more information on InDesign scripting, go to http://www.adobe.com/products/indesign/scripting.html
//Or visit the InDesign Scripting User to User forum at http://www.adobeforums.com.

//ģ顢ֿƸĽ ζ ɣиĽϵ leo@china.com 
if (app.documents.length > 0){
	if (app.selection.length > 0){
		switch(app.selection[0].constructor.name){
			case "Rectangle":
			case "Oval":
			case "Polygon":
			case "GraphicLine":
			case "Group":
			case "TextFrame":
			case "Button":
				myDisplayDialog();
				break;
			default:			
				alert("ѡҳĿԡ");
				break;
		}
	}
	else{
		alert("ѡԡ");
	}
}
else{
	alert("½ĵѡԡ");
}
function myDisplayDialog(){
	var myDialog, myRangeGuttons, myBasedOnButtons;
	with(myDialog = app.dialogs.add({name:"Ӹ"})){
		with(dialogColumns.add()){
			with(borderPanels.add()){
				staticTexts.add({staticLabel:":"});
				with(dialogColumns.add()){					
					var myTopCheckbox = checkboxControls.add({staticLabel:"", checkedState:true});
					var myLeftCheckbox = checkboxControls.add({staticLabel:"", checkedState:true});
					var myBottomCheckbox = checkboxControls.add({staticLabel:"ײ", checkedState:true});
					var myRightCheckbox = checkboxControls.add({staticLabel:"Ҳ", checkedState:true});
					var myXCenterCheckbox = checkboxControls.add({staticLabel:"ֱ", checkedState:true});
					var myYCenterCheckbox = checkboxControls.add({staticLabel:"ˮƽ          ", checkedState:true});
				}
			}
			with(borderPanels.add()){
				staticTexts.add({staticLabel:"ӷʽ:"});
				with(myRangeButtons = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"", checkedState:true});
					radiobuttonControls.add({staticLabel:"ѡ           "});
				}
			}
			with(borderPanels.add()){
				staticTexts.add({staticLabel:"ӻ׼:"});
				with(myBasedOnButtons = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"ڼηΧ", checkedState:true});
					radiobuttonControls.add({staticLabel:"ڿɼΧ     "});
				}
			}
			//߲;ԡ///ʼ
			//
			with(borderPanels.add()){
				staticTexts.add({staticLabel:":"});
				with(myLockGuidesLayerButtons = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"߲", checkedState:true});
					radiobuttonControls.add({staticLabel:"Ÿ߲"});
				}
				with(myAddNewLayerButtons = radiobuttonGroups.add()){
					radiobuttonControls.add({staticLabel:"²"});
					radiobuttonControls.add({staticLabel:"ԭ", checkedState:true});
				}
			}
			//
			with(borderPanels.add()){
				staticTexts.add({staticLabel:"иĽϵleo@china.com"});
			}
			//߲;ԡ///
		}
	}
	myReturn = myDialog.show();
	if (myReturn == true){
		//ȡƲ
		var myTop = myTopCheckbox.checkedState;
		var myLeft = myLeftCheckbox.checkedState;
		var myBottom = myBottomCheckbox.checkedState;
		var myRight = myRightCheckbox.checkedState;
		var myXCenter = myXCenterCheckbox.checkedState;
		var myYCenter = myYCenterCheckbox.checkedState;
		var myBasedOn = myBasedOnButtons.selectedButton;
		var myRange = myRangeButtons.selectedButton;
		//߲;ԡ
		var myLockGuidesLayer = myLockGuidesLayerButtons.selectedButton;
		//߲;ԡ
		//²
		var myAddNewLayer = myAddNewLayerButtons.selectedButton;
		//²
		//նԻ
		myDialog.destroy();
		if(myTop+myLeft+myBottom+myRight+myXCenter+myYCenter !=0){
			myAddGuides(myTop, myLeft, myBottom, myRight, myXCenter, myYCenter, myRange, myBasedOn);
			//߲
			myLockGuidesLayerFunction (myLockGuidesLayer);
			//߲
			//½
			myAddNewLayerFunction (myAddNewLayer);
			//½
		}
		else{
			alert("ָһ߲ԡ");
			myDisplayDialog();
		}
	}
	else{
		//նԻ
		myDialog.destroy();
	}
}
function myAddGuides(myTop, myLeft, myBottom, myRight, myXCenter, myYCenter, myRange, myBasedOn){
	var myLayer, myCounter;
	//Create a layer to hold the printers marks (if it does not already exist).
	myLayer = app.activeDocument.layers.item("");
	//⸨
	myCheckLayerLock ();
	//⸨
	try{
		myLayerName = myLayer.name;
	}
	catch (myError){
		myLayer = app.activeDocument.layers.add({name:""});
	}
	//Process the objects in the selection.		
	for(myCounter = 0; myCounter < app.selection.length; myCounter ++){
		var myObject = app.selection[myCounter];
		if (myBasedOn == 0){
			myBounds = myObject.visibleBounds;
		}
		else{
			myBounds = myObject.geometricBounds;
		}
		//Set up some initial bounding box values.
		if ((myRange != 0)&&(myCounter==0)){
			myX1 = myBounds[1];
			myY1 = myBounds[0];
			myX2 = myBounds[3];
			myY2 = myBounds[2];
		}
		if(myRange == 0){
			myDrawGuides (myBounds[1], myBounds[0], myBounds[3], myBounds[2], myTop, myLeft, myBottom, myRight, myXCenter, myYCenter, myLayer);
		}
		else{
			//Compare the bounds values to the stored bounds.
			//If a given bounds value is less than (for x1 and y1) or 
			//greater than (for x2 and y2) the stored value,
			//then replace the stored value with the bounds value.
			if (myBounds[0] < myY1){
				myY1 = myBounds[0];
			}
			if (myBounds[1] < myX1){
				myX1 = myBounds[1];
			}
			if (myBounds[2] > myY2){
				myY2 = myBounds[2];
			}
			if (myBounds[3] > myX2){
				myX2 = myBounds[3];
			}
		}
	}
	if(myRange != 0){
		myDrawGuides (myX1, myY1, myX2, myY2, myTop, myLeft, myBottom, myRight, myXCenter, myYCenter, myLayer);
	}
}
function myDrawGuides(myX1, myY1, myX2, myY2, myTop, myLeft, myBottom, myRight, myXCenter, myYCenter, myLayer){
	if (myTop == true){
		myDrawGuide(myY1, 0);
	}
	if (myLeft == true){
		myDrawGuide(myX1, 1);
	}
	if (myBottom == true){
		myDrawGuide(myY2, 0);
	}
	if (myRight == true){
		myDrawGuide(myX2, 1);
	}
	if (myXCenter == true){
		myDrawGuide(myX1+((myX2-myX1)/2), 1);
	}
	if (myYCenter == true){
		myDrawGuide(myY1+((myY2-myY1)/2), 0);
	}
}
function myDrawGuide(myGuideLocation, myGuideOrientation){
	var myLayer = app.activeDocument.layers.item("");
	with(app.activeWindow.activeSpread){
			with(myLayer.locked = false){
				if(myGuideOrientation == 0){
					with (guides.add(myLayer, undefined, undefined)){
						orientation=HorizontalOrVertical.horizontal;
						location=myGuideLocation;
					}
				}
				else{
					with (guides.add(myLayer, undefined, undefined)){
						orientation=HorizontalOrVertical.vertical;
						location=myGuideLocation;
					}
			}
		}
	}
}
//߲㲢½;ԡ///ʼ
function myLockGuidesLayerFunction (myLockGuidesLayer){
	var myLayer/*, myNewLayer*/
	myLayer = app.activeDocument.layers.item("");
	if (myLockGuidesLayer == 0){
		myLayer.locked = true;
		alert("߲");
	}else{
		myLayer.locked = false;
		alert("߲δ");
	}
}
//߲㲢½;ԡ///
//⸨///ʼ
function myCheckLayerLock (){
	if (app.activeDocument.layers.item("") == true){
		var myLayer = app.activeDocument.layers.item("");
		if(myLayer.locked == true){
			myLayer.locked = false;
			alert("߲Ѵ򿪡");
		}
	}
}
//⸨///
//߲///ʼ
function myAddNewLayerFunction (myAddNewLayer){
	var myNewLayer
	if (myAddNewLayer == 0){
		myNewLayer = app.activeDocument.layers.add();
		alert("²ӡ");
	}else{
		alert("ԭޱ仯");
	}
}
//߲///