//////////////////////////////////////////////////////////// english //
// ---------------------
// -=> WR-collect_ID <=-
// ---------------------
//
// A Javascript for Adobe InDesign CS
// by Wolfgang Reszel (ai-js@rumborak.de)
//
// Version 0.1 from 13.8.2004
//
// This script collects all linked files into a subfolder of the
// documents folder (linked images).
//
// You can customize the foldername for the images by changing the line
//  var linkedimagesfolder = "links";
//
// To collect to a copy to a new folder first save your document, then
// save it to a new folder and execute this script. Let the script set
// the paths of the linked items to the new folder and again save the
// document.
//
// To enable the english messages change the "de" into "en" in line 60.
//
// Sorry for my bad english. For any corrections send an email to:
// ai-js@rumborak.de
//
//////////////////////////////////////////////////////////// Deutsch //
// ---------------------
// -=> WR-collect_ID <=-
// ---------------------
//
// Ein Javascript fuer Adobe InDesign CS
// von Wolfgang Reszel (ai-js@rumborak.de)
//
// Version 0.1 vom 13.8.2004
//
// Dieses Skript sammelt alle veknuepften Dateien in einen Unterordner
// des Ordners, wo das aktive Dokument gespeichert ist.
//
// Der Ordnername fuer die verknuepften Dateien kann durch Aendern der
// wie folgend ausehenden Zeile angepasst werden.
//  var linkedimagesfolder = "Bilder";
//
// Um das Dokument mitsamt seinen verknuepften Dateien in einen neuen
// Ordner zu sammeln, muss dieses zuerst gesichert werden. Danach
// speichert man es in den gewuenschten Ordner und fuehrt dieses Skript
// aus. Die Dateipfade der Verknuepfungen muessen vom Skript angepasst
// werden, worauf man das Dokument dann nochmals speichert.
//
// Um dieses Skript mit deutschen Meldungen zu versehen, muss in Zeile
// 60 das "en" durch ein "de" ersetzt werden.
//
// Verbesserungsvorschlaege an: ai-js@rumborak.de
//

//$.bp();

// -------------------------------------------------------------------

var language="en";   // "de" fuer Deutsch

// -------------------------------------------------------------------

var WR="ռļָļ v0.1\n\n";

if (language == "de") {

 var MSG_ask = WR+"In welchen Unterordner des Dokuments m\xF6chtest du alle verkn\xFCpften Dateien sammeln?";
 var MSG_correctlinks = WR+"Sollen die Dateipfade der Verkn\xFCpfungen angepasst werden?";
 var MSG_statuslinked = "Gesammelte Verkn\xFCpfungen: ";
 var MSG_errors = " (Fehler: ";
 var MSG_statuscorrect = "\nDie Dateipfade der Verkn\xFCpfungen wurden angepasst.";
 var MSG_statuscorrectno = "\nDie Dateipfade der Verkn\xFCpfungen wurden nicht angepasst.";
 var MSG_notsaved = WR+"Dieses Dokument wurde noch nicht gespeichert, bitte holen Sie das nach.";
 var MSG_nodocs = WR+"Kein Dokument ge\xF6ffnet."
 var MSG_alreadycollected = WR+"Es wurden bereits alle Verkn\xFCpfungen gesammelt."

} else {

 var linkedimagesfolder = "links";

 var MSG_ask = WR+"ҪռĿô?ָĵǰĵĿ¼µļơ";
 var MSG_correctlinks = WR+"Ƿļ·Ҳָļ?";
 var MSG_statusplaced = "ռ: ";
 var MSG_errors = " (Errors: ";
 var MSG_statuscorrect = "\nļ·Ѿָļ";
 var MSG_statuscorrectno = "\nļ·ûиı䡣";
 var MSG_notsaved = WR+"ǰĵûб棬ȱ档";
 var MSG_nodocs = WR+"ǰûд򿪵ļ"
 var MSG_alreadycollected = WR+"ĿѾռ"

}

var error=0;

try{app.activeDocument.fullName} catch(e) {error=1;}

if (app.documents.length==0) {
  alert(MSG_nodocs);
} else if ( error == 1) {
  alert(MSG_notsaved);
}

if (error == 0) {
	 var linkedimagesfolder = "Link";

 	if (app.activeDocument.label != "") { linkedimagesfolder = app.activeDocument.label; }

	if (linkedimagesfolder=prompt(MSG_ask,linkedimagesfolder)) {
	  if (error < 1 && alreadycollected()>0 ) {
		 app.activeDocument.label = linkedimagesfolder;
		 collect();
	  }
	}
}

function alreadycollected() {
  var theLinks = app.activeDocument.links;
  var imagesfolder = app.activeDocument.filePath+"/"+linkedimagesfolder+"/";

  var newItems=0;

  for (var i = 0 ; i < theLinks.length; i++)
  {
      if(theLinks[i].filePath != File(imagesfolder+theLinks[i].name).fullName) {newItems++;}
  }

  if (newItems==0) { alert(MSG_alreadycollected); }

  return newItems;
}

function collect() {
  var theLinks = app.activeDocument.links;

  var correctlinks = confirm(MSG_correctlinks);

  var imagesfolder = app.activeDocument.filePath+"/"+linkedimagesfolder+"/";

  var folder = new Folder(imagesfolder);

  var linkedImages=0;
  var linkedErrors=0;

  folder.create();

  for (var i = 0 ; i < theLinks.length; i++)
  {
    source = theLinks[i];

    target = imagesfolder+theLinks[i].name;

    if (source.status == LinkStatus.linkMissing) {
      linkedErrors++;
      theLinks[i].select(true);
    }

    if (source.filePath != target && source.status != LinkStatus.linkMissing) {
		linkedImages++;
      if(theLinks[i].filePath != File(imagesfolder+theLinks[i].name).fullName) {
      	if (!File(source.filePath).copy(target)) {linkedErrors++;}
      }

      if (correctlinks == true) {
      	theLinks[i].relink(File(target));
      }
    }
  }

  var linksMSG="";
  if (linkedErrors>0) {var linksMSG= MSG_errors+linkedErrors+")";}

  status=MSG_statuslinked+linkedImages+linksMSG;
  if (correctlinks==true) {status=status+MSG_statuscorrect; } else {status=status+MSG_statuscorrectno; }

  alert(status);

}
