//ExportAllStories.js
//An InDesign CS JavaScript
//
//Exports all stories in an InDesign document in a specified text format.
//
//For more on InDesign scripting, go to http://www.adobe.com/products/indesign/scripting.html
//or visit the InDesign Scripting User to User forum at http://www.adobeforums.com
//
if(app.documents.length != 0){
	if (app.activeDocument.stories.length != 0){
		with(myDialog = app.dialogs.add({name:"ı"})){
			//Add a dialog column.
			myDialogColumn = dialogColumns.add()	
			with(myDialogColumn){
				with(borderPanels.add()){
					staticTexts.add({staticLabel:"Ϊ:"});
					with(myExportFormatButtons = radiobuttonGroups.add()){
						radiobuttonControls.add({staticLabel:"ı", checkedState:true});
						radiobuttonControls.add({staticLabel:"RTFı"});
						radiobuttonControls.add({staticLabel:"InDesignı"});
					}
				}
			}
			myReturn = myDialog.show();
			if (myReturn == true){
				//Get the values from the dialog box.
				myExportFormat = myExportFormatButtons.selectedButton;
				myDialog.destroy;
				myFolder= Folder.selectDialog ("ѡһļ");
				if((myFolder != null)&&(app.activeDocument.stories.length !=0)){
					myExportAllStories(myExportFormat, myFolder);
				}
			}
			myDialog.destroy();
		}
	}
	else{
		alert("ǰĵûаκıһıĵȻһΡ");
	}
}
else{
	alert("ûд򿪵ĵһĵȻһΡ");
}
//myExportStories function takes care of exporting the stories.
//myExportFormat is a number from 0-2, where 0 = text only, 1 = rtf, and 3 = tagged text.
//myFolder is a reference to the folder in which you want to save your files.
function myExportAllStories(myExportFormat, myFolder){
	for(myCounter = 0; myCounter < app.activeDocument.stories.length; myCounter++){
		myStory = app.activeDocument.stories.item(myCounter);
		myID = myStory.id;
		switch(myExportFormat){
			case 0:
				myFormat = ExportFormat.textType;
				myExtension = ".txt"
				break;
			case 1:
				myFormat = ExportFormat.RTF;
				myExtension = ".rtf"
				break;
			case 2:
				myFormat = ExportFormat.taggedText;
				myExtension = ".txt"
				break;
		}
		myFileName = "IDı" + myID + myExtension;
		myFilePath = myFolder + "/" + myFileName;
		myFile = new File(myFilePath);
		myStory.exportFile(myFormat, myFile);
	}
}